﻿/**
 * @author kubaszek
 * 
 */
class pN {
	
public static var max_N:Number = 64; //PN digits number - can be changed before start of calc.
//Uwaga - w pierwotnej bibliotece było -1
/*
public static var TRACE_OPER_on    		=	true;
public static var TRACE_DIGITS_on  		=	true;

public static var TRACE_WARNING_ON  	=	true;
public static var TRACE_ERROR_ON  		=	true;
/*/
public static var TRACE_OPER_on    		=	false;
public static var TRACE_DIGITS_on  		=	false;

public static var TRACE_WARNING_ON  	=	false;
public static var TRACE_ERROR_ON  		=	false;
/* */


//constant of constructor operations:

public static var PN1_MUL    		=	10;// a * x
public static var PN1_PWR    		=	11;// x ^ a
//public static var PN1_INV    		=	12;// a * 1 / x
//public static var PN1_SQR    		=	13;// x^2
//public static var PN1_SQRT   		=	14;// sqrt(x)
public static var PN1_EXP    		=	15;// a * exp(x)
public static var PN1_LN    		=	16;// a * ln(x)
//public static var PN1_SIN    		=	17;// sin(x)
//public static var PN1_COS    		=	18;// cos(x)

public static var PN2_ADD    		=	50;// ( x + y ) *a
public static var PN2_SUB    		=	51;// ( x - y ) *a
public static var PN2_MUL    		=	52;// ( x * y ) *a
public static var PN2_DIV    		=	53;// ( x / y ) *a

public static var CONST_1    	=	100;//{  a  * (~1~)              }
public static var CONST_10    	=	101;//{  a  * (~1~0~)            }
public static var CONST_P_TRAP	=	102;//{ 4*a * (~0.5~,-1~1~-1~...)  }, a=1/h
public static var CONST_P_PROST	=	103;//{  a  * (~1~,-1~)          }, a=1/h
public static var CONST_05111	=	104;//{  a  * (~0.5~, 1~1~1~... )}
public static var CONST_1111 	=	105;//{  a  * (~1~, 1~1~1~... )  }
public static var CONST_P_TRAP_PWR_2 =106;//{ ( 4*a * (~0.5~,-1~1~-1~...) )^2  }, a=1/h

//////////////////////////////////

public var mant: Array = null;//new Array();/*0..max_N-1*/
//public var mant: /*Number*/  Array = null;//new Array();/*0..max_N-1*/
//MTASC - Strictly typed arrays

public var chrtic:Number = 0;/*integer*/

//If name of x or y param. of constructor is empty, than param. 
//is deleted at the end of constructor.

//used in toString and echoMsg:
public var name:String="";
public var a_mul :Number = 1;//to scale PN str.
public static var max_N_str:Number = 10; // <= max_N
//////////////////////////////////

public static var PN1_OP_STR :Array = new Array(
"PN1_MUL","PN1_PWR","PN1_INV","PN1_SQR","PN1_SQRT","PN1_EXP","PN1_LN","PN1_SIN","PN1_COS");
public static var PN2_OP_STR :Array = new Array(
"PN2_ADD","PN2_SUB","PN2_MUL","PN2_DIV");
public static var CONST_OP_STR :Array = new Array(
"CONST_1","CONST_10","CONST_P_TRAP","CONST_P_PROST","CONST_05111","CONST_1111",
"CONST_P_TRAP_PWR_2");

public function getPN_operStr( pN_oper :Number ):String {
	if ( pN_oper < PN1_MUL ) return "unknow op.";
	if ( pN_oper < PN2_ADD ) return PN1_OP_STR[pN_oper - PN1_MUL];
	if ( pN_oper < CONST_1 ) return PN2_OP_STR[pN_oper - PN2_ADD];
							 return CONST_OP_STR[pN_oper - CONST_1];
}
public function toString():String {
	var s :String, max_N_tmp :Number;

	max_N_tmp = Math.min(pN.max_N_str, pN.max_N )
	s = "";
	if ( this.a_mul != 1 ) s += this.a_mul+ " * ";
	s += "(~"+(this.mant[0]/this.a_mul)+"~, ";
	for ( var k = 0;  ++k < max_N_tmp; ) {
		s += (this.mant[k]/this.a_mul) + "~";
	} 
	if ( max_N_tmp < pN.max_N )
		s += "...~";
	s += ")";
	if ( this.chrtic != 0 )
		s +=" * (~1~0~)^("+this.chrtic+")";
	return( s );
}

public function toStringNm():String {
	return ( this.name+" = "+this.toString() );
}

/////////////////////////////////////////////////////////////////////

public function pN(nm:String, pN_oper :Number, a :Number, x :pN, y :pN ) {
/**
 * If name of x or y param. of constructor is empty, than param. 
 * is deleted at the end of constructor. 
 */

var i:Number, j:Number, k:Number;
	var xTmp:pN=x, yTmp:pN=y;
	var x0:Number = 0;
	this.chrtic = 0;
	this.mant = new Array(pN.max_N);/*0..max_N-1*/

	//this.mant.length = pN.max_N;//for ( i = pN.max_N; --i >=0; ) this.mant[i] = 0; 

	//useful for toString:
	this.name = nm;
	this.a_mul = a;

	if ( pN.TRACE_OPER_on ) trace(nm+": "+getPN_operStr(pN_oper)+"  "+a+"*  "
		+(x!=undefined? " :"+x.name :"")+(y!=undefined? " :"+y.name :""));
		
	switch ( pN_oper ) {

	case PN1_MUL    		: //	10;// a * x
		this.chrtic = x.chrtic;
		for (k = pN.max_N; --k >= 0; ) this.mant[k] = a * x.mant[k];
		break;
		
	case PN1_PWR    		: //	11;// x ^ a
		var chrtic_p :Number= x.chrtic * a;/*float*/
		this.chrtic = Math.round(chrtic_p);
		// - only integers are aceptable:
		if ( Math.abs( (this.chrtic - chrtic_p) ) > 1e-9 ) {
			if ( pN.TRACE_ERROR_ON ) {
					trace("Error: During  PN1_PWR operation chrtic "+chrtic_p+
					" is different from integer !!!");
			}
			else this.chrtic = NaN;
		}
		for (k = pN.max_N; --k >= 0; ) this.mant[k] = 0;
		if ( x.mant[0] <= 0 ) {
			if ( pN.TRACE_ERROR_ON ) {
					trace("Error: {X**a} 1st digit of X:  "+x.mant[0]+
					" < 0 !!!");
			}
		}
		this.mant[0] = Math.pow(x.mant[0], a); //exp(a*ln(x[0]))
		a += 1;
		for ( k = 1; k < pN.max_N; ++k ) {
			for ( j = 1;  j <= k; ++j )
				this.mant[k] += x.mant[j] * this.mant[k-j] * (a*j/k -1);
			this.mant[k] /= x.mant[0];
		}
		break;
/*		
	case PN1_INV    		: //	12;// a / x
	case PN1_SQR    		: //	13;// x^2
	case PN1_SQRT    		: //	14;// sqrt(x)
		this.chrtic = x.chrtic;
		break;
*/		
	case PN1_EXP     		: //	15;// a * exp(x)
		this.chrtic = x.chrtic;

	    x0 = Math.exp(x.mant[0]);
		this.mant[0] = x0;

		for ( k = 1; k < pN.max_N; ++k ) {
			this.mant[k] = x.mant[k] * x0;
			for ( j = 1;  j < k; ++j )
				this.mant[k] += x.mant[k-j] * this.mant[j] * (1-j/k);
		}
		if ( a != 1 ) for (k = pN.max_N; --k >= 0; ) this.mant[k] *= a;
		break;

	case PN1_LN     		: //	16;// a * ln(x)
		this.mant[0] = Math.log(x.mant[0]);

		for ( k = 1; k < pN.max_N; ++k ) {
			this.mant[k] = x.mant[k]
			for ( j = 1;  j < k; ++j )
				this.mant[k] -= x.mant[j] * this.mant[k-j] * (1-j/k);
			this.mant[k] /= x.mant[0];
		}
		if ( a != 1 ) for (k = pN.max_N; --k >= 0; ) this.mant[k] *= a;
		break;

//	case PN1_SIN    		: //	17;// sin(x)
//	case PN1_COS    		: //	18;// cos(x)

	case PN2_ADD    		: //	50;// ( x + y ) *a
	case PN2_SUB    		: //	51;// ( x - y ) *a
		if ( x.chrtic >= y.chrtic ) {
			//xTmp = x; yTmp = y; - see var...
		} else {
			xTmp = y; yTmp = x;
		}			
		this.chrtic = xTmp.chrtic ;
		j = xTmp.chrtic - yTmp.chrtic ;
		for ( k = Math.min(j,pN.max_N); --k >= 0; )
			this.mant[k] = xTmp.mant[k] * a;
			
		if ( pN_oper == PN2_ADD ) {
			for ( k = j; k < pN.max_N; ++k )
				this.mant[k] = ( xTmp.mant[k] + yTmp.mant[k-j] ) * a;
		} else {
			for ( k = j; k < pN.max_N; ++k )
				this.mant[k] = ( xTmp.mant[k] - yTmp.mant[k-j] ) * a;
		}			
		//normalization - mant[0] should not be zero (or almost 0... -not implemented)
		j = 0; while ( ( j < pN.max_N ) && ( this.mant[j] == 0 ) ) ++j;
		if ( j >= pN.max_N ) {//all pN digits are equal to zero:
			this.chrtic = 0;
		} else if ( j > 0 ) {//move digits
			for ( k = j; k < pN.max_N; ++k )
				this.mant[k-j] = this.mant[k];
			for ( k = pN.max_N-j; k < pN.max_N; ++k )
				this.mant[k] = 0;
            this.chrtic -= j;
			if ( pN.TRACE_WARNING_ON ) {
				trace("Warninig: During  "+
					(( pN_oper == PN2_ADD )?"[ + ]":"[ - ]")+" operation "+
					j+" significant PN digit(s) is(are) lost !!!");
			}
		}
		break;

	case PN2_MUL    		: //	52;// ( x * y ) *a
		this.chrtic = x.chrtic + y.chrtic ;
		for ( k = 0;  k < pN.max_N; ++k) {
			this.mant[k] = 0;
			for ( j = 0;  j <= k; ++j )
				this.mant[k] += x.mant[k-j] * y.mant[j];
		}
		if ( a != 1 ) for (k = pN.max_N; --k >= 0; ) this.mant[k] *= a;
		break;
		
	case PN2_DIV    		: //	53;// ( x / y ) *a
		this.chrtic = x.chrtic - y.chrtic ;
		for ( k = 0;  k < pN.max_N; ++k) {
			this.mant[k] = x.mant[k];;
			for ( j = 0;  j < k; ++j )
				this.mant[k] -= y.mant[k-j] * this.mant[j];
			this.mant[k] *= 1 / y.mant[0];
		}
		if ( a != 1 ) for (k = pN.max_N; --k >= 0; ) this.mant[k] *= a;
		break;

	case CONST_1     	: //	100;//{  a  * (~1~)              }
		//this.chrtic = 0;
		this.mant[0] = a;
		for (k = pN.max_N;  --k > 0; )
		  this.mant[k] = 0;
		break;

	case CONST_10    	: //	101;//{  a  * (~1~0~)            }
		this.chrtic = 1;
		this.mant[0] = a;
		for (k = pN.max_N;  --k > 0; )
		  this.mant[k] = 0;
		break;

	case CONST_P_TRAP	: //	102;//{ 4*a * (~0.5~,-1~1~-1~...)  }, a=1/h
		//this.chrtic = 0;
		this.mant[0] = 2*a ;// 2/h
		j =  -4*a ;// -4/h
		for (k = 0;  ++k < pN.max_N; ) { 
			this.mant[k] = j;
			j = -j;
		}
		break;
		
	case CONST_P_TRAP_PWR_2	://	106;//{ (4*a * (~0.5~,-1~1~-1~...))^2  }, a=1/h
		//this.chrtic = 0;
		this.mant[0] = 2*2*a*a ;// (2/h)^2
		j =  -4*4*a*a ;// -4/h
		for (k = 0;  ++k < pN.max_N; ) { 
			this.mant[k] = j*k;
			j = -j;
		}
		break;
		
	case CONST_P_PROST	: //	103;//{ 1*a * (~1~,-1~)          }, a=1/h
		//this.chrtic = 0;
		this.mant[0] = a ;// 1/h;
		this.mant[1] = -this.mant[0];
		for (k = pN.max_N;  --k > 1; )
		  this.mant[k] = 0;
		break;

	case CONST_05111 	: //	104;//{  a  * (~0.5~, 1~1~1~... )}
		//this.chrtic = 0;
		this.mant[0] = a/2;
		for (k = pN.max_N;  --k > 0; )
		  this.mant[k] = a;
		break;

	case CONST_1111  	: //	105;//{  a  * (~1~, 1~1~1~... )  }
		//this.chrtic = 0;
		for (k = pN.max_N;  --k >= 0; )
		  this.mant[k] = a;
		break;

	default : break;
	}
	if ( pN.TRACE_DIGITS_on ) trace(this.toStringNm());
	
	if (x.name == "") delete x;
	if (y.name == "") delete y;
}


}